## deepin-log-viewer 6.5.7+ds1

=== debian/changelog ===
deepin-log-viewer (6.5.7+ds1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * debian/control: Tighten version requirement of libdtk.
  * debian/patches: Refresh patches.

 -- Boyuan Yang <byang@debian.org>  Tue, 11 Feb 2025 19:38:53 -0500
