=== debian/changelog ===
deepin-log-viewer (6.5.8+ds1-2) unstable; urgency=medium

  * Team upload.
  * Rebuild with libxlsxwriter 1.2.3.

 -- Boyuan Yang <byang@debian.org>  Wed, 13 Aug 2025 15:22:21 -0400

deepin-log-viewer (6.5.8+ds1-1) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Mon, 03 Mar 2025 11:27:02 -0500

deepin-log-viewer (6.5.8+ds1-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Test rebuild against libxlsxwriter 1.2.1.
  * debian/rules: Drop unused LIB_INSTALL_DIR variable.
  * debian/control: Temporarily build-depends on libdtklog-dev.

 -- Boyuan Yang <byang@debian.org>  Sun, 02 Mar 2025 14:29:28 -0500
