=== debian/control ===
--- 
+++ 
@@ -9,8 +9,8 @@
  cmake,
  libboost-dev,
  libdframeworkdbus-dev (>= 6),
- libdtkgui-dev (>= 5.7.6),
- libdtkwidget-dev (>= 5.7.6),
+ libdtkgui-dev (>= 5.7.11),
+ libdtkwidget-dev (>= 5.7.11),
  libgio-qt-dev,
  libgmock-dev,
  libgsettings-qt-dev,
@@ -23,7 +23,7 @@
  libqt5svg5-dev,
  libsystemd-dev,
  libxerces-c-dev,
- libxlsxwriter-dev (>= 1.1.9),
+ libxlsxwriter-dev (>= 1.2.1),
  libzip-dev,
  pkgconf,
  qt5-qmake,
@@ -31,7 +31,7 @@
  qttools5-dev,
  qttools5-dev-tools,
  rapidjson-dev,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://github.com/linuxdeepin/deepin-log-viewer
 Vcs-Git: https://salsa.debian.org/pkg-deepin-team/deepin-log-viewer.git
