=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

opts="dversionmangle=auto, \
   filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%deepin-log-viewer-$1.tar.gz%, \
   oversionmangle=s/(.*)/$1+ds1/" \
   https://github.com/linuxdeepin/deepin-log-viewer/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
