## deepin-log-viewer 6.5.9

=== debian/changelog ===
deepin-log-viewer (6.5.9) unstable; urgency=medium

  * chore: New version 6.5.9.

 -- Wang Yu <wangyu@uniontch.com>  Thu, 27 Mar 2025 13:42:54 +0800

deepin-log-viewer (6.5.8) unstable; urgency=medium

  * chore: New version 6.5.8.

 -- xiepengfei <xiepengfei@uniontech.com>  Fri, 14 Feb 2025 09:17:33 +0800

deepin-log-viewer (6.5.7) unstable; urgency=medium

  * chore: New version 6.5.7.
  * fix: Fix can not get any logs issue

 -- re2zero <yangwu@uniontech.com>  Sat, 08 Feb 2025 15:51:30 +0800

deepin-log-viewer (6.5.6) unstable; urgency=medium

  * chore: New version 6.5.6.
  * feat: Support Qt6 build.

 -- re2zero <yangwu@uniontech.com>  Mon, 20 Jan 2025 16:30:43 +0800

deepin-log-viewer (6.5.5) unstable; urgency=medium

  * chore: New version 6.5.5.

 -- xiepengfei <xiepengfei@uniontech.com>  Thu, 16 Jan 2025 13:23:42 +0800

deepin-log-viewer (6.5.4) unstable; urgency=medium

  * treeland start app crash 

 -- Liu zheng <liuzheng@uniontech.com>  Fri, 13 Dec 2024 17:12:28 +0800

deepin-log-viewer (6.5.3) unstable; urgency=medium

  * fix: [cmd] Remove bash command invoke and DBus security reinforcement(Task: 362319)
  * fix: fix 3 security vulnerabilities(Bug: 278915)
  * fix: fix compile problem(Bug: 278915)
  * chore: [security] strong the dbus interface(Task: 365257)
  * fix: fix boot log no content problem(Bug: 278915)
  * fix: Fixed the issue of repeatedly popping up authentication windows when exporting logs(Bug: 278819)
  * fix: Fixed the issue of repeatedly popping up authentication windows when exporting logs 2nd(Bug: 278819)
  * fix: Fixed the issue of multiple authentication windows popping up in audit logs(Bug: 281209)
  * fix: Fixed the issue of multiple authentication windows popping up for certain types(Bug: 281209)
  * fix: [theme] Resolve the issue of incorrect color display when switching themes on the log details page(Bug: 281647)
  * fix: [ts] Xorg log offset international translation copywriting adjustment
  * fix: Security reinforcement only authentication(TWB)

 -- renbin <renbin@uniontech.com>  Sat, 07 Dec 2024 12:04:01 +0800
