## deepin-log-viewer 6.5.10+ds1

=== debian/changelog ===
deepin-log-viewer (6.5.10+ds1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * debian/control: Drop unused libdframeworkdbus-dev build-dep.
  * debian/control: Bump Standards-Version to 4.7.3.

 -- Boyuan Yang <byang@debian.org>  Sat, 17 Jan 2026 16:05:55 -0500
