=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: deepin-log-viewer
 Section: misc
-Priority: optional
 Maintainer: Debian Deepin Packaging Team <pkg-deepin-devel@lists.alioth.debian.org>
 Uploaders:
  Ma Aiguo <imaiguo@gmail.com>,
@@ -8,7 +7,6 @@
  debhelper-compat (= 13),
  cmake,
  libboost-dev,
- libdframeworkdbus-dev (>= 6),
  libdtkgui-dev (>= 5.7.11),
  libdtkwidget-dev (>= 5.7.11),
  libgio-qt-dev,
@@ -23,7 +21,7 @@
  libqt5svg5-dev,
  libsystemd-dev,
  libxerces-c-dev,
- libxlsxwriter-dev (>= 1.2.1),
+ libxlsxwriter-dev (>= 1.2.3),
  libzip-dev,
  pkgconf,
  qt5-qmake,
@@ -31,8 +29,7 @@
  qttools5-dev,
  qttools5-dev-tools,
  rapidjson-dev,
-Standards-Version: 4.7.2
-Rules-Requires-Root: no
+Standards-Version: 4.7.3
 Homepage: https://github.com/linuxdeepin/deepin-log-viewer
 Vcs-Git: https://salsa.debian.org/pkg-deepin-team/deepin-log-viewer.git
 Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/deepin-log-viewer
