=== debian/changelog ===
deepin-log-viewer (6.5.17) unstable; urgency=medium

  * update translations.

 -- Liuyangming <liuyangming@uniontech.com>  Thu, 26 Jun 2025 14:20:58 +0800

deepin-log-viewer (6.5.16) unstable; urgency=medium

  * chore: Update deepin-manual resources

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Mon, 23 Jun 2025 14:40:56 +0800

deepin-log-viewer (6.5.15) unstable; urgency=medium

  * update translations.

 -- Liuyangming <liuyangming@uniontech.com>  Mon, 23 Jun 2025 11:52:38 +0800

deepin-log-viewer (6.5.14) unstable; urgency=medium

  * chore: Add compile flags for deepin-log-viewer

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Thu, 19 Jun 2025 21:50:45 +0800

deepin-log-viewer (6.5.13) unstable; urgency=medium

  * add compile flags.  

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Wed, 18 Jun 2025 11:20:55 +0800

deepin-log-viewer (6.5.12) unstable; urgency=medium

  * Update deepin-manual resources. 

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Tue, 17 Jun 2025 17:24:38 +0800

deepin-log-viewer (6.5.11) unstable; urgency=medium

  * update version to 6.5.11
  * Add linglong desktop file path.

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Fri, 25 Apr 2025 17:10:21 +0800

deepin-log-viewer (6.5.10) unstable; urgency=medium

  * chore: update desktop file
  * chore: update translations.

 -- renbin <renbin@uniontech.com>  Thu, 17 Apr 2025 10:44:49 +0800
